/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.TipoCortesiaDescuentoDAO;
import com.rjconsultores.ventaboletos.entidad.TipoCortesia;
import com.rjconsultores.ventaboletos.entidad.TipoCortesiaDescuento;
import java.math.BigDecimal;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Shiro
 */
@Repository("tipoCortesiaDescuentoDAO")
public class TipoCortesiaDescuentoHibernateDAO
        extends GenericHibernateDAO<TipoCortesiaDescuento, Integer>
        implements TipoCortesiaDescuentoDAO {

    @Autowired
    public TipoCortesiaDescuentoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<TipoCortesiaDescuento> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

    public List<TipoCortesiaDescuento> pesquisar(TipoCortesia tipoCortesia) {

        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        if (tipoCortesia != null) {
            c.add(Restrictions.eq("tipoCortesia", tipoCortesia));
        }
        return c.list();
    }

    public List<TipoCortesiaDescuento> Onchangue(TipoCortesia tp) {

        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));


        if (tp != null) {
            c.add(Restrictions.eq("tipoCortesia", tp));
        }
        return c.list();
    }

    public List<TipoCortesiaDescuento> buscar(BigDecimal porcentaje,
            TipoCortesia tipoCortesia) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        c.add(Restrictions.eq("porcdescuento", porcentaje));
        c.add(Restrictions.eq("tipoCortesia", tipoCortesia));

        return c.list();
    }

    public List<TipoCortesiaDescuento> obtenerTipoCortesia(int i) {
        Criteria c = getSession().createCriteria(getPersistentClass());

        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("tipoCortesia.tipocortesiaId", new Integer(i).shortValue()));

        return c.list();
    }
}
